#include "qgraphicssepiaeffect.h"

QGraphicsSepiaEffect::QGraphicsSepiaEffect(QObject *parent)
{

}

void QGraphicsSepiaEffect::draw(QPainter *painter)
{
    QImage image = sourcePixmap().toImage();

    for(int i=0; i<image.width(); i++)
    {
        for(int j=0; j<image.height(); j++)
        {
            int red =
                    qRed(image.pixel(i,j)) * 0.393 +
                    qGreen(image.pixel(i,j)) * 0.769 +
                    qBlue(image.pixel(i,j)) * 0.189;

            if(red > 255 ) red = 255;

            int green =
                    qRed(image.pixel(i,j)) * 0.349 +
                    qGreen(image.pixel(i,j)) * 0.686 +
                    qBlue(image.pixel(i,j)) * 0.168;

            if(green > 255) green = 255;

            int blue =
                    qRed(image.pixel(i,j)) * 0.272 +
                    qGreen(image.pixel(i,j)) * 0.534 +
                    qBlue(image.pixel(i,j)) * 0.131;

            if(blue > 255) blue = 255;

            image.setPixel(i,j, qRgba(red, green, blue, qAlpha(image.pixel(i,j))));

        }
    }

    painter->drawPixmap(0,0, QPixmap::fromImage(image));
}
